diff --git a/public/flutter.js b/public/flutter.js
index aaf9775aa89c..d3efa7fd80d9 100644
--- a/public/flutter.js
+++ b/public/flutter.js
@@ -72,8 +72,7 @@ _flutter.loader = null;
      */
     constructor(validPatterns, policyName = "flutter-js") {
       const patterns = validPatterns || [
-        /\.dart\.js$/,
-        /^flutter_service_worker.js$/
+        /\.js$/,
       ];
       if (window.trustedTypes) {
         this.policy = trustedTypes.createPolicy(policyName, {
@@ -116,10 +115,19 @@ _flutter.loader = null;
      * @returns {Promise} that resolves when the latest serviceWorker is ready.
      */
     loadServiceWorker(settings) {
-      if (!("serviceWorker" in navigator) || settings == null) {
+      if (settings == null) {
         // In the future, settings = null -> uninstall service worker?
+        console.debug("Null serviceWorker configuration. Skipping.");
+        return Promise.resolve();
+      }
+      if (!("serviceWorker" in navigator)) {
+        let errorMessage = "Service Worker API unavailable.";
+        if (!window.isSecureContext) {
+          errorMessage += "\nThe current context is NOT secure."
+          errorMessage += "\nRead more: https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts";
+        }
         return Promise.reject(
-          new Error("Service worker not supported (or configured).")
+          new Error(errorMessage)
         );
       }
       const {
@@ -373,4 +381,3 @@ _flutter.loader = null;
 
   _flutter.loader = new FlutterLoader();
 })();
-
